package com.loafle.overflow.probe.container.server;

import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.Channel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PreDestroy;
import java.net.InetSocketAddress;

@Component
public class ContainerServer {
    @Autowired
    private ServerBootstrap serverBootstrap;

    @Autowired
    private InetSocketAddress socketAddress;

    private Channel channel;

    public ContainerServer() {

    }

    public void start() throws Exception {
        channel = serverBootstrap.bind(socketAddress).sync().channel().closeFuture().sync().channel();
    }

    @PreDestroy
    public void stop() throws Exception {
        channel.close();
        channel.parent().close();
    }
}
